      REAL FUNCTION CHEB (X)  
C  RETURNS THE VALUE OF THE POLYNOMIAL OF DEGREE .LT. NTERMS WHOSE
C  CHEBYSHEV COEFFICIENTS ARE CONTAINED IN  D . 
      INTEGER NTERMS,   K     
      REAL D,X,   PREV,PREV2,TWOX   
      COMMON /POLY/ NTERMS,D(30)    
      IF ( NTERMS .EQ. 1) THEN
         CHEB = D(1)    
                                        RETURN  
      END IF
      TWOX = 2.*X 
      PREV2 = 0.  
      PREV = D(NTERMS)  
      IF (NTERMS .GT. 2) THEN 
         DO 10 K=NTERMS-1,2,-1
            CHEB = D(K) + TWOX*PREV - PREV2     
            PREV2 = PREV
            PREV = CHEB 
   10    CONTINUE 
      END IF
      CHEB = D(1) + X*PREV - PREV2  
                                        RETURN  
      END   
